- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# PK_CryptoSystem Class Reference

`#include <cryptlib.h>`

Inheritance diagram for PK_CryptoSystem:

List of all members.

## Detailed Description

interface for public-key encryptors and decryptors

This class provides an interface common to encryptors and decryptors for querying their plaintext and ciphertext lengths.

Definition at line 1126 of file cryptlib.h.

## Public Member Functions
virtual | ~PK_CryptoSystem ()
virtual size_t | MaxPlaintextLength (size_t ciphertextLength) const =0
| maximum length of plaintext for a given ciphertext length
virtual size_t | CiphertextLength (size_t plaintextLength) const =0
| calculate length of ciphertext given length of plaintext
virtual bool | ParameterSupported (const char *name) const =0
| this object supports the use of the parameter with the given name
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0

## Member Function Documentation

virtual size_t PK_CryptoSystem::MaxPlaintextLength | ( | size_t | ciphertextLength | ) | const`[pure virtual]`

maximum length of plaintext for a given ciphertext length

Note:
  This function returns 0 if ciphertextLength is not valid (too long or too short).

Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

Referenced by PK_DefaultDecryptionFilter::Put2().

virtual size_t PK_CryptoSystem::CiphertextLength | ( | size_t | plaintextLength | ) | const`[pure virtual]`

calculate length of ciphertext given length of plaintext

Note:
  This function returns 0 if plaintextLength is not valid (too long).

Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

Referenced by PK_DefaultEncryptionFilter::Put2().

virtual bool PK_CryptoSystem::ParameterSupported | ( | const char * | name | ) | const`[pure virtual]`

this object supports the use of the parameter with the given name

some possible parameter names: EncodingParameters, KeyDerivationParameters

Implemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const`[inline, virtual]`

return fixed ciphertext length, if one exists, otherwise return 0

Note:
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Reimplemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, and TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >.

Definition at line 1146 of file cryptlib.h.

Referenced by PK_Decryptor::FixedLengthDecrypt().

The documentation for this class was generated from the following file:

- cryptlib.h